# test file for paillier crypto system (http://services.informatik.hs-mannheim.de/kryptolern/paillier_gmp.php)
# description in http://en.wikipedia.org/wiki/Paillier_cryptosystem

/^#/{}         # comment line, ignore
/^[ \t]*$/{}   # empty line, ignore

/^[0-9]/{
      /* encryption parameter */
   p = next_prime($1)
   q = next_prime($2)
   g = $3
   r = $4

      /* number to encrypt */
   m_e = $5
      /* number to decrypt */
   m_d = $6;

   n = p * q
   n2 = n * n
   lambda = (p - 1) * (q - 1) / gcd(p - 1, q - 1)
   mu = powm((powm(g, lambda, n2) - 1)/n, -1, n)

      /* encrypt a number, then decrypt to check */
   c  = powm(g, m_e, n2) * powm(r, n, n2) % n2
   cd = (powm(c, lambda, n2) - 1)/n * mu % n

      /* decrypt a number */
   d = (powm(m_d, lambda, n2) - 1) / n * mu % n

      /* print out just the used encryption parameters and results */
   printf("input:       p = %d, q = %d\nused values: p = %d, q = %d, g = %d, r = %d\n   public key: n = %d, g = %d\n" \
      "   private key: lambda = %d, mue = %d\n   encryption of %d: %d (decrypted: %d)\n   decryption: %d\n\n",
         $1, $2, p, q, g, r, n, g, lambda, mu, m_e, c, cd, d);
}
